<?php
//C:\workfolder\v_220\products\sources\modules\Scheduler\Logic\consumer.php
require_once __DIR__.'../../../../../projects/scheduler/public/bootstrap.php';
require_once 'ReportSender.php';
require_once 'MailSender.php';
require_once 'ProcedureRunner.php';
set_time_limit(0);

class Consumer{
    const GET_PROCESSO_EXECUCAO = "SELECT *
            FROM (SELECT TP.PROCESS_PATH, TPQ.TKU_PROCESS_QUEUE_ID, TPQ.PROCESS_PARAMS, TPQ.NRORG
                FROM TKU_PROCESS_QUEUE TPQ
                LEFT JOIN TKU_PROCESS TP ON
                TPQ.TKU_PROCESS_ID=TP.TKU_PROCESS_ID
                WHERE TPQ.STATUS='EXECUCAO' ORDER BY TPQ.PRIORITY ASC)
            WHERE ROWNUM<=5";
    const UPDATE_PROCESSO = "UPDATE TKU_PROCESS_QUEUE SET STATUS='EXECUTADO' WHERE TKU_PROCESS_QUEUE_ID=";
    const GET_SERVERS="SELECT SERVER_ADDRESS, PORT FROM TKU_PROCESS_MANAGER";

    public static function standByConsumer(){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $array_servidores=$db->fetchAll(Consumer::GET_SERVERS);
        $hasGearman=false;
        if (!empty($array_servidores)){
            $client = new GearmanClient();
            foreach ($array_servidores as $servidor){
                try{
                    $result=$client->addServer($servidor["SERVER_ADDRESS"], $servidor["PORT"]);
                    $hasGearman=$result||$hasGearman;
                }catch(GearmanException $e){
                    echo $e->getMessage();
                    echo "O IP $servidor[SERVER_ADDRESS] nao pode ser registrado";
                }
            }
        }
//        echo 'oi';

//        file_put_contents("/var/www/homologacao/products/sources/modules/Scheduler/Logic/log.txt","start");
        while(true){
            sleep(2);
//            sleep(1800);//change back to 2
//            $file="\n".now();
//            file_put_contents("/var/www/homologacao/products/sources/modules/Scheduler/Logic/log.txt",$file,FILE_APPEND);
//            echo 'oi2';
            try{
                //pega todos os processos com status EXECUCAO
                $lista_processos=$db->fetchAll(Consumer::GET_PROCESSO_EXECUCAO);

                foreach ($lista_processos as $processo){

                    register_shutdown_function(Array('Consumer','reviveConsumer'), $processo['TKU_PROCESS_QUEUE_ID']);

                    $jobArray[]=$processo['PROCESS_PARAMS'];
                    $jobArray[]=$processo['NRORG'];

                    try{
                        if ($hasGearman){
                            $client->doBackground($processo['PROCESS_PATH'], $jobArray);
                        }
                        else{
                            self::doJob($processo['PROCESS_PATH'], $jobArray);
                        }
                    }
                    catch(\Exception $e){
                        $id=$processo['TKU_PROCESS_QUEUE_ID'];
                        $markasfail="UPDATE TKU_PROCESS_QUEUE SET STATUS='ERRO' WHERE TKU_PROCESS_QUEUE_ID=$id";
                        $db = \Setforms2\Runtime\Connection::getInstance();
                        $db->execute($markasfail);
                        \Scheduler\Logic\MailSender::sendErrorEmail("Erro - ".$e->getMessage());
                    }
            //        echo($processo[PROCESS_PATH]=="send_report");
            //		if ($processo[PROCESS_PATH]=="send_report"){
            //          echo "achei um processo";
            //		  ReportSender::mandar_relatorio($processo[PROCESS_PARAMS]);
            //            $client->doBackground("send_email", ($processo[TPQ.PROCESS_PARAMS]));
            //	    }
            //        var_dump($processo);
                    $db->execute(Consumer::UPDATE_PROCESSO.$processo['TKU_PROCESS_QUEUE_ID']);
                }
            }
            catch(\Doctrine2\DBAL\Driver\OCI8\OCI8Exception $e){
//                $logger=\Setforms2\Runtime\Logger::getInstance();
//                $logger->error($e->getMessage());
                \Scheduler\Logic\MailSender::sendErrorEmail("Erro de DB - ".$e->getMessage());
            }
            catch(\Exception $e){
//                $logger=\Setforms2\Runtime\Logger::getInstance();
//                $logger->error($e->getMessage());
                \Scheduler\Logic\MailSender::sendErrorEmail("Erro - ".$e->getMessage());
            }
        }
    }



    public static function consumerOnDemand($param){

        /**
         * Created by JetBrains PhpStorm.
         * User: geovanesantos
         * Date: 26/03/14
         * Time: 11:22
         * To change this template use File | Settings | File Templates.
         */
//        require_once '../../../../projects/scheduler/public/bootstrap.php';
        require_once "../Entities/TkuProcessQueue.php";
        require_once "../Entities/TkuProcess.php";

        //$serverExists=false;
        //$serverWorks=false;
        $db = \Setforms2\Runtime\Connection::getInstance();
        $array_servidores=$db->fetchAll(Consumer::GET_SERVERS);

        //testa se há algum worker do gearman disponível
        $hasGearman = false;
        if (!empty($array_servidores)){
            $client = new GearmanClient();
            foreach ($array_servidores as $servidor){
                try{
                    //echo "might be";
                    $result=$client->addServer($servidor["SERVER_ADDRESS"], $servidor["PORT"]);
                    //echo "working";
                    $hasGearman=$result||$hasGearman;
                }catch(GearmanException $e){
                    echo $e->getMessage();
                    echo "O IP $servidor[SERVER_ADDRESS] nao pode ser registrado";
                }
            }
        }
        try{
//            register_shutdown_function(Array('Consumer','markAsFailure'), $param);

            $processQueueArr=\Scheduler\Entities\TkuProcessQueue::findByTkuProcessQueueIdAndStatus($param,"AGENDADO");
            $processQueue=$processQueueArr[0];

            $processArr=\Scheduler\Entities\TkuProcess::findByTkuProcessId($processQueue->getTkuProcessId());
            $process=$processArr[0];

            $jobArray[]=$processQueue->getProcessParams();;
            $jobArray[]=$processQueue->getNrorg();

//            if ($hasGearman){
//                $client->doBackground($process->getProcessPath(), $processQueue->getProcessParams());
//            }
//            else{
//                self::doJob($process->getProcessPath(), $processQueue->getProcessParams());
//            }
            try{
                if ($hasGearman){
                    $client->doBackground($process->getProcessPath(), $jobArray);
                }
                else{
                    self::doJob($process->getProcessPath(), $jobArray);
                }
            }
            catch(\Exception $e){
//                $queryParams['P_ID']=$param;
//                $markasfail="UPDATE TKU_PROCESS_QUEUE SET STATUS='ERRO' WHERE TKU_PROCESS_QUEUE_ID=:P_ID";
//                $db = \Setforms2\Runtime\Connection::getInstance();
//                $db->execute($markasfail,$queryParams);
                \Scheduler\Logic\MailSender::sendErrorEmail("Erro - ".$e->getMessage());
                throw new \Exception("Erro - ".$e->getMessage());
            }

        }
        catch(\Doctrine2\DBAL\Driver\OCI8\OCI8Exception $e){
//            $logger=\Setforms2\Runtime\Logger::getInstance();
//            $logger->error($e->getMessage());
            \Scheduler\Logic\MailSender::sendErrorEmail("Erro de DB - ".$e->getMessage());
            throw new \Exception("Erro de DB - ".$e->getMessage());
        }
        catch (\Exception $e){
//            $logger=\Setforms2\Runtime\Logger::getInstance();
//            $logger->error($e->getMessage());
            \Scheduler\Logic\MailSender::sendErrorEmail("Erro - ".$e->getMessage());
            throw new \Exception("Erro - ".$e->getMessage());
        }

    }


    public static function checkForGearman(){
        //$serverExists=false;
        //$serverWorks=false;
        //@TODO implementar isso no consumer
        $db = \Setforms2\Runtime\Connection::getInstance();
        $array_servidores=$db->fetchAll(Consumer::GET_SERVERS);

        //testa se há algum worker do gearman disponível
        $hasGearman = false;
        if (!empty($array_servidores)){
            $client = new GearmanClient();
            foreach ($array_servidores as $servidor){
                try{
                    //echo "might be";
                    $result=$client->addServer($servidor["SERVER_ADDRESS"], $servidor["PORT"]);
                    //echo "working";
                    $hasGearman=$result||$hasGearman;
                }catch(GearmanException $e){
//                    echo $e->getMessage();
//                    echo "O IP $servidor[SERVER_ADDRESS] nao pode ser registrado";
                }
            }
        }
        if ($hasGearman) return $client;
        else return false;
    }



    public static function doJob($job, $workload){

        $nrorg=array_pop($workload);
        if(empty($nrorg)){
            $nrorg=1;
        }

        $workload=array_pop($workload);

        switch ($job){
            case "send_report":
                try{
                    \Scheduler\Logic\ReportSender::mandar_relatorio($workload,$nrorg);
                }
                catch(\Exception $e){
//                    $logger=\Setforms2\Runtime\Logger::getInstance();
//                    $logger->error($e->getMessage());
//                    echo $e->getMessage();
                    throw new Exception("send_report - ".$e->getMessage());
                }
                break;

            case "send_email":
                try{
                    \Scheduler\Logic\MailSender::mandar_email($workload,$nrorg); break;
                }
                catch(\Exception $e){
//                    $logger=\Setforms2\Runtime\Logger::getInstance();
//                    $logger->error($e->getMessage());
//                    echo $e->getMessage();
                    throw new Exception("send_email - ".$e->getMessage());
                }
                break;

            case "run_procedure":
                try{
                    \Scheduler\Logic\ProcedureRunner::executa_procedure($workload,$nrorg);
                }
                catch(\Exception $e){
//                    $logger=\Setforms2\Runtime\Logger::getInstance();
//                    $logger->error($e->getMessage());
//                    echo $e->getMessage();
                    throw new Exception("run_procedure - ".$e->getMessage());
                }
                break;
            case "run_dll":
                try{
                    \Scheduler\Logic\DLLRunner::runDLL($workload,$nrorg);
                }
                catch(\Exception $e){
//                    $logger=\Setforms2\Runtime\Logger::getInstance();
//                    $logger->error($e->getMessage());
//                    echo $e->getMessage();
                    throw new Exception("run_dll - ".$e->getMessage());
                }
        }


    }


    public static function markAsFailure($id){

        if (@is_array($e = @error_get_last()) && ($e['type'] === E_ERROR || $e['type'] === E_USER_ERROR)) {
            $markasfail="UPDATE TKU_PROCESS_QUEUE SET STATUS='ERRO' WHERE TKU_PROCESS_QUEUE_ID=$id";
            $db = \Setforms2\Runtime\Connection::getInstance();
            $db->execute($markasfail);
            $file = isset($e['file']) ? $e['file'] : '';
            $line = isset($e['line']) ? $e['line'] : '';
            $msg = isset($e['message']) ? $e['message'] : '';
            $msg .= " at {$file}({$line}).";
            \Scheduler\Logic\MailSender::sendErrorEmail("Erro fatal: - ".$msg);
        }
    }

    public static function reviveConsumer($id){  //revives the process when dead

        if (@is_array($e = @error_get_last()) && ($e['type'] === E_ERROR || $e['type'] === E_USER_ERROR)) {
            $markasfail="UPDATE TKU_PROCESS_QUEUE SET STATUS='ERRO' WHERE TKU_PROCESS_QUEUE_ID=$id";
            $db = \Setforms2\Runtime\Connection::getInstance();
            $db->execute($markasfail);
            $file = isset($e['file']) ? $e['file'] : '';
            $line = isset($e['line']) ? $e['line'] : '';
            $msg = isset($e['message']) ? $e['message'] : '';
            $msg .= " at {$file}({$line}).";
            \Scheduler\Logic\MailSender::sendErrorEmail("Erro fatal: - ".$msg);

//            file_put_contents("log.txt", $msg."\n", FILE_APPEND);

//            session_destroy();

            if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
                $WshShell = new \COM('WScript.Shell');
                $oExec = $WshShell->Run('php consumerStandBy.php', 0, false);

            } else {
                exec('service consumerStandBy restart');
            }

            exit(); //na verdade é desnecessário, já que o comando anterior faz o processo se matar, mas w/e
        }
    }


}
